## dogtag-pki 10.2.6+git20160317

=== CMakeLists.txt ===
project(pki)

# Required cmake version
cmake_minimum_required(VERSION 2.6.0)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# Un-comment the following line to add 'javac' options (e. g. - "-g" debugging)
#set(CMAKE_JAVA_COMPILE_FLAGS "-g")

if (NOT DEFINED VERSION)
    set(VERSION "10.0.0")
endif(NOT DEFINED VERSION)

string(REGEX REPLACE "^([0-9]+).*" "\\1" APPLICATION_VERSION_MAJOR ${VERSION})
string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*" "\\1" APPLICATION_VERSION_MINOR ${VERSION})
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1" APPLICATION_VERSION_PATCH ${VERSION})

option(WITH_TOMCAT7 "Build Tomcat 7" ON)
option(WITH_TOMCAT8 "Build Tomcat 8" ON)
option(WITH_SERVER "Build Server" ON)
option(WITH_JAVADOC "Build Javadoc" ON)

if (BUILD_DOGTAG_PKI_THEME)
    set(APPLICATION_FLAVOR_DOGTAG_PKI_THEME TRUE)
elseif (BUILD_REDHAT_PKI_THEME)
    set(APPLICATION_FLAVOR_REDHAT_PKI_THEME TRUE)
elseif (BUILD_PKI_CORE)
    set(APPLICATION_FLAVOR_PKI_CORE TRUE)
elseif (BUILD_PKI_CONSOLE)
    set(APPLICATION_FLAVOR_PKI_CONSOLE TRUE)
endif ()

set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")

# where to look first for cmake modules
# (before ${CMAKE_ROOT}/Modules/ is checked)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

# add definitions
include(DefineCMakeDefaults)
include(DefinePlatformDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions.cmake)
include(CPackConfig.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# add macros
include(MacroCopyFile)
include(Java)

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/classes)
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/dist)

# required for all PKI components
include(JUnit)

add_custom_target(unit-test)

# search for libraries

# required for all PKI components EXCEPT Theme-based components
if (NOT APPLICATION_FLAVOR_DOGTAG_PKI_THEME   AND
    NOT APPLICATION_FLAVOR_REDHAT_PKI_THEME)
    find_package(NSPR REQUIRED)
    find_package(NSS REQUIRED)
endif ()

# ONLY required for Java-based PKI components
if (APPLICATION_FLAVOR_PKI_CORE         OR
    APPLICATION_FLAVOR_PKI_CONSOLE      OR
    APPLICATION_FLAVOR_DOGTAG_PKI_THEME OR
    APPLICATION_FLAVOR_REDHAT_PKI_THEME)
    find_package(Java REQUIRED)
    find_package(JNI REQUIRED)
endif ()

# ONLY required for PKI_CORE
if (APPLICATION_FLAVOR_PKI_CORE)
    find_package(Ldap REQUIRED)
    # required for native 'tpsclient' utility
    find_package(APR REQUIRED)
    find_package(Svrcore REQUIRED)
endif ()

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

find_package(PythonInterp REQUIRED)
execute_process(
    COMMAND
        ${PYTHON_EXECUTABLE} -c
        "from distutils.sysconfig import get_python_lib; print get_python_lib()"
    OUTPUT_VARIABLE
        PYTHON_SITE_PACKAGES
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_definitions(-DHAVE_CONFIG_H)

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)

add_custom_target(uninstall
                  COMMAND ${CMAKE_COMMAND}
                      -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# clean-dist target
add_custom_target(clean-dist
    COMMAND ${CMAKE_COMMAND}
        -E remove_directory ${CMAKE_BINARY_DIR}/dist
)

# clean-cmake target
add_custom_target(clean-cmake
    COMMAND ${CMAKE_COMMAND}
        -E remove_directory ${CMAKE_BINARY_DIR}/base
    COMMAND ${CMAKE_COMMAND}
        -E remove_directory ${CMAKE_BINARY_DIR}/CMakeFiles
    COMMAND ${CMAKE_COMMAND}
        -E remove -f
        ${CMAKE_BINARY_DIR}/CMakeCache.txt
        ${CMAKE_BINARY_DIR}/cmake_install.cmake
        ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
        ${CMAKE_BINARY_DIR}/config.h
        ${CMAKE_BINARY_DIR}/CPackConfig.cmake
        ${CMAKE_BINARY_DIR}/CPackSourceConfig.cmake
        ${CMAKE_BINARY_DIR}/install_manifest.txt
        ${CMAKE_BINARY_DIR}/Makefile
)

# check subdirectories
if (APPLICATION_FLAVOR_PKI_CORE      OR
    APPLICATION_FLAVOR_PKI_CONSOLE)
    add_subdirectory(base)
endif ()

# 'Themes' MUST be "mutually-exclusive"!
if (APPLICATION_FLAVOR_DOGTAG_PKI_THEME)
    add_subdirectory(dogtag)
elseif (APPLICATION_FLAVOR_REDHAT_PKI_THEME)
    add_subdirectory(redhat)
endif ()

=== dogtag/CMakeLists.txt ===
project(dogtag)

if (APPLICATION_FLAVOR_DOGTAG_PKI_THEME)
    add_subdirectory(common-ui)
    add_subdirectory(console-ui)
endif (APPLICATION_FLAVOR_DOGTAG_PKI_THEME)

=== base/javadoc/CMakeLists.txt ===
project(pki-javadoc)

# It is important to identify the version of 'javadoc' being utilized since
# different versions support different options.
#
# While 'cmake' contains numerous built-in references to the 'java' version,
# it contains no built-in references to either the 'javac' or 'javadoc'
# versions, and unfortunately, the specified version of 'java' may be
# different from the specified versions of 'javac' and 'javadoc'.
#
# Additionally, although 'javadoc' contains no command-line option to identify
# its version, it is important to note that 'javadoc' is supplied by the same
# package that supplies 'javac', and although multiple versions of these
# executables could co-exist on the same system, it is relatively safe to
# assert that the currently specified 'javac' and 'javadoc' will be the same
# version.
#
# As an example in support of this assertion, on systems which utilize
# '/usr/sbin/alternatives', setting the 'javac' version will also
# automatically set the 'javadoc' version to match the 'javac' version, and
# 'usr/sbin/alternatives' cannot be used to set a specific 'javadoc' version.
#
# Therefore, regardless of the 'java' version, this 'CMakeLists.txt' file will
# programmatically utilize the invoked 'javac' version information (output is
# to stderr) in order to correctly identify the supported 'javadoc' options:
#
#     # javac -version 2>&1 | awk -F \. '{printf $2}'
#
# NOTE:  Used 'cut' instead of 'awk' due to 'cmake' parsing limitations:
#
#     # javac -version 2>&1 | cut -f2 -d.
#
message( STATUS "Java_VERSION_STRING = '${Java_VERSION_STRING}'" )
execute_process(
    COMMAND
        javac -version
    ERROR_VARIABLE
        Javac_VERSION_OUTPUT
    OUTPUT_VARIABLE
        Javac_VERSION_OUTPUT
    ERROR_STRIP_TRAILING_WHITESPACE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
message( STATUS "Javac_VERSION_OUTPUT = '${Javac_VERSION_OUTPUT}'" )
execute_process(
    COMMAND
        echo ${Javac_VERSION_OUTPUT}
    COMMAND
        cut -f2 -d.
    OUTPUT_VARIABLE
        Javadoc_VERSION_MINOR
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
message( STATUS "Javadoc_VERSION_MINOR = '${Javadoc_VERSION_MINOR}'" )

# REMINDER:  Eventually, it would almost certainly be safer to obtain the
#            'Javadoc_VERSION_MAJOR' number as well and perform the check
#            on "'Javadoc_VERSION_MAJOR'.'Javadoc_VERSION_MINOR'".
#
set(doclintstr "")
if(NOT (${Javadoc_VERSION_MINOR} LESS 8))
    set(doclintstr "-Xdoclint:none")
endif(NOT (${Javadoc_VERSION_MINOR} LESS 8))

javadoc(pki-javadoc
    SOURCEPATH
        ${CMAKE_SOURCE_DIR}/base/util/src
        ${CMAKE_SOURCE_DIR}/base/common/src
        ${CMAKE_SOURCE_DIR}/base/java-tools/src
        ${CMAKE_SOURCE_DIR}/base/server/cms/src
    DEST
        ${CMAKE_CURRENT_BINARY_DIR}/javadoc/pki-${APPLICATION_VERSION}
    SUBPACKAGES
        com.netscape.certsrv
        com.netscape.cms
        com.netscape.cmstools
        com.netscape.cmsutil
        org.dogtagpki
    CLASSPATH
        ${XALAN_JAR} ${XERCES_JAR}
        ${APACHE_COMMONS_CLI_JAR} ${APACHE_COMMONS_LANG_JAR}
        ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR} ${COMMONS_IO_JAR}
        ${LDAPJDK_JAR} ${VELOCITY_JAR}
        ${JSS_JAR} ${SYMKEY_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR}
        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR} ${RESTEASY_CLIENT_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_TOMCAT_JAR} ${PKI_CMS_JAR} ${PKI_TOOLS_JAR}
        ${NUXWDOG_JAR}
    OPTIONS
        -windowtitle 'pki-javadoc'
        -doctitle '<h1>PKI Javadoc</h1>'
        -author
        -use
        -version
        ${doclintstr}
    DEPENDS
        pki-cmsutil-jar pki-certsrv-jar pki-tomcat-jar pki-cms-jar pki-tools-jar
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/javadoc/pki-${APPLICATION_VERSION}
    DESTINATION
        ${CMAKE_INSTALL_PREFIX}/share/javadoc
)

=== base/kra/CMakeLists.txt ===
project(kra NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)

if(WITH_TOMCAT7)
    add_subdirectory(tomcat7)
endif(WITH_TOMCAT7)

if(WITH_TOMCAT8)
    add_subdirectory(tomcat8)
endif(WITH_TOMCAT8)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
    PATTERN
        "conf/CS.cfg.in" EXCLUDE
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/kra
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/kra
)

=== base/ocsp/CMakeLists.txt ===
project(ocsp NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)

if(WITH_TOMCAT7)
    add_subdirectory(tomcat7)
endif(WITH_TOMCAT7)

if(WITH_TOMCAT8)
    add_subdirectory(tomcat8)
endif(WITH_TOMCAT8)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
    PATTERN
        "CS.cfg.in" EXCLUDE
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/ocsp
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/ocsp
)

=== base/tks/CMakeLists.txt ===
project(tks NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)

if(WITH_TOMCAT7)
    add_subdirectory(tomcat7)
endif(WITH_TOMCAT7)

if(WITH_TOMCAT8)
    add_subdirectory(tomcat8)
endif(WITH_TOMCAT8)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
    PATTERN
        "CS.cfg.in" EXCLUDE
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tks
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tks
)

=== base/tps/CMakeLists.txt ===
project(tps Java)

add_subdirectory(src)

# install files
add_subdirectory(setup)
add_subdirectory(shared/conf)

if(WITH_TOMCAT7)
    add_subdirectory(tomcat7)
endif(WITH_TOMCAT7)

if(WITH_TOMCAT8)
    add_subdirectory(tomcat8)
endif(WITH_TOMCAT8)

# install manual pages
install(
    DIRECTORY
        man/
    DESTINATION
        ${MAN_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
    PATTERN
        "conf/CS.cfg.in" EXCLUDE
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tps
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tps
)

=== dogtag/common-ui/CMakeLists.txt ===
project(common-ui)

install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
)

=== base/console/src/CMakeLists.txt ===
project(pki-console_java NONE)

# '/usr/share/java/pki' jars
find_file(PKI_NSUTIL_JAR
    NAMES
        pki-nsutil.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java/pki
)

find_file(PKI_CERTSRV_JAR
    NAMES
        pki-certsrv.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java/pki
)

find_file(PKI_CMSUTIL_JAR
    NAMES
        pki-cmsutil.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java/pki
)


# '/usr/share/java' jars
find_file(BASE_JAR
    NAMES
        idm-console-base.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(LDAPJDK_JAR
    NAMES
        ldapjdk.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(MMC_JAR
    NAMES
        idm-console-mcc.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(MMC_EN_JAR
    NAMES
        idm-console-mcc_en.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(NMCLF_JAR
    NAMES
        idm-console-nmclf.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(NMCLF_EN_JAR
    NAMES
        idm-console-nmclf_en.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)


# '${JAVA_LIB_INSTALL_DIR}' jars
find_file(JSS_JAR
    NAMES
        jss4.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(COMMONS_CODEC_JAR
    NAMES
        commons-codec.jar
    PATHS
        /usr/share/java
)

# build console classes
javac(pki-console-classes
    SOURCES
        com/netscape/admin/certsrv/*.java
    CLASSPATH
        ${CMAKE_BINARY_DIR}/classes
        ${BASE_JAR} ${LDAPJDK_JAR} ${MMC_JAR}
        ${MMC_EN_JAR} ${NMCLF_JAR} ${NMCLF_EN_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_NSUTIL_JAR} ${PKI_CERTSRV_JAR}
        ${JSS_JAR} ${COMMONS_CODEC_JAR}
    OUTPUT_DIR
        ${CMAKE_BINARY_DIR}/classes
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/pki-console.mf
    ${CMAKE_CURRENT_BINARY_DIR}/pki-console.mf
)

# package console classes and resources
jar(pki-console-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-console.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/pki-console.mf
    INPUT_DIR
        ${CMAKE_BINARY_DIR}/classes
    FILES
        com/netscape/admin/certsrv/*.class
    INPUT_DIR
        ${CMAKE_CURRENT_SOURCE_DIR}
    FILES
        com/netscape/admin/certsrv/images/*.gif
    DEPENDS
        pki-console-classes
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-console.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

set(PKI_CONSOLE_JAR ${CMAKE_BINARY_DIR}/dist/pki-console.jar CACHE INTERNAL "pki-console jar file")

=== base/java-tools/src/CMakeLists.txt ===
project(pki-tools_java NONE)

find_file(JSS_JAR
    NAMES
        jss4.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(LDAPJDK_JAR
    NAMES
        ldapjdk.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(APACHE_COMMONS_CLI_JAR
    NAMES
        apache-commons-cli.jar
    PATHS
        /usr/share/java
)

find_file(APACHE_COMMONS_LANG_JAR
    NAMES
        apache-commons-lang.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_CODEC_JAR
    NAMES
        commons-codec.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_IO_JAR
    NAMES
        commons-io.jar
    PATHS
        /usr/share/java
)

find_file(XALAN_JAR
    NAMES
        xalan-j2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XERCES_JAR
    NAMES
        xerces-j2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(JAXRS_API_JAR
    NAMES
        jaxrs-api.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_JAXRS_JAR
    NAMES
        resteasy-jaxrs.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_ATOM_PROVIDER_JAR
    NAMES
        resteasy-atom-provider.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(HTTPCLIENT_JAR
    NAMES
        httpclient.jar
    PATHS
        /usr/share/java/httpcomponents
)

find_file(HTTPCORE_JAR
    NAMES
        httpcore.jar
    PATHS
        /usr/share/java/httpcomponents
)

# build pki-tools
javac(pki-tools-classes
    SOURCES
        com/netscape/cmstools/*.java
    CLASSPATH
        ${PKI_NSUTIL_JAR} ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR}
        ${XALAN_JAR} ${XERCES_JAR}
        ${JSS_JAR} ${LDAPJDK_JAR} ${COMMONS_CODEC_JAR} ${COMMONS_IO_JAR}
        ${APACHE_COMMONS_CLI_JAR} ${APACHE_COMMONS_LANG_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR}
        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
    OUTPUT_DIR
        ${CMAKE_BINARY_DIR}/classes
    DEPENDS
        pki-nsutil-jar pki-cmsutil-jar pki-certsrv-jar
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/pki-tools.mf
    ${CMAKE_CURRENT_BINARY_DIR}/pki-tools.mf
)

jar(pki-tools-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-tools.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/pki-tools.mf
    INPUT_DIR
        ${CMAKE_BINARY_DIR}/classes
    FILES
        com/netscape/cmstools/*.class
    DEPENDS
        pki-tools-classes
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-tools.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

install(
    FILES
        com/netscape/cmstools/DRMTool.cfg
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/pki/java-tools
)

set(PKI_TOOLS_JAR ${CMAKE_BINARY_DIR}/dist/pki-tools.jar CACHE INTERNAL "pki-tools jar file")

=== base/server/tomcat7/src/CMakeLists.txt ===
project(pki-tomcat7)

find_file(JSS_JAR
    NAMES
        jss4.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(LDAPJDK_JAR
    NAMES
        ldapjdk.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(COMMONS_CODEC_JAR
    NAMES
        commons-codec.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_HTTPCLIENT_JAR
    NAMES
        commons-httpclient.jar
    PATHS
        /usr/share/java
)

find_file(APACHE_COMMONS_LANG_JAR
    NAMES
        apache-commons-lang.jar
    PATHS
        /usr/share/java
)

find_file(TOMCAT_CATALINA_JAR
    NAMES
        catalina.jar
    PATHS
        /usr/share/java/tomcat
)

find_file(TOMCAT_UTIL_SCAN_JAR
    NAMES
        tomcat-util-scan.jar
    PATHS
        /usr/share/java/tomcat
)

find_file(SERVLET_JAR
    NAMES
        servlet.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(VELOCITY_JAR
    NAMES
        velocity.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XALAN_JAR
    NAMES
        xalan-j2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XERCES_JAR
    NAMES
        xerces-j2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(JAXRS_API_JAR
    NAMES
        jaxrs-api.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_JAXRS_JAR
    NAMES
        resteasy-jaxrs.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_ATOM_PROVIDER_JAR
    NAMES
        resteasy-atom-provider.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(HTTPCLIENT_JAR
    NAMES
        httpclient.jar
    PATHS
        /usr/share/java/httpcomponents
)

find_file(HTTPCORE_JAR
    NAMES
        httpcore.jar
    PATHS
        /usr/share/java/httpcomponents
)

# build pki-tomcat
javac(pki-tomcat7-classes
    SOURCES
        com/netscape/cms/tomcat/*.java
    CLASSPATH
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_SCAN_JAR}
    OUTPUT_DIR
        ${CMAKE_BINARY_DIR}/../../tomcat
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/pki-tomcat.mf
    ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
)

jar(pki-tomcat-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
    INPUT_DIR
        ${CMAKE_BINARY_DIR}/../../tomcat
    FILES
        com/netscape/cms/tomcat/*.class
    DEPENDS
        pki-tomcat-classes
        pki-tomcat7-classes
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

set(PKI_TOMCAT_JAR ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar CACHE INTERNAL "pki-tomcat jar file")

=== base/server/tomcat8/src/CMakeLists.txt ===
project(pki-tomcat8)

find_file(JSS_JAR
    NAMES
        jss4.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(LDAPJDK_JAR
    NAMES
        ldapjdk.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(COMMONS_CODEC_JAR
    NAMES
        commons-codec.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_HTTPCLIENT_JAR
    NAMES
        commons-httpclient.jar
    PATHS
        /usr/share/java
)

find_file(APACHE_COMMONS_LANG_JAR
    NAMES
        apache-commons-lang.jar
    PATHS
        /usr/share/java
)

find_file(TOMCAT_CATALINA_JAR
    NAMES
        catalina.jar
    PATHS
        /usr/share/java/tomcat
)

find_file(TOMCAT_API_JAR
    NAMES
        tomcat-api.jar
    PATHS
        /usr/share/java/tomcat
)

find_file(TOMCAT_UTIL_SCAN_JAR
    NAMES
        tomcat-util-scan.jar
    PATHS
        /usr/share/java/tomcat
)

find_file(SERVLET_JAR
    NAMES
        servlet.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(VELOCITY_JAR
    NAMES
        velocity.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XALAN_JAR
    NAMES
        xalan-j2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XERCES_JAR
    NAMES
        xerces-j2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(JAXRS_API_JAR
    NAMES
        jaxrs-api.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_JAXRS_JAR
    NAMES
        resteasy-jaxrs.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_ATOM_PROVIDER_JAR
    NAMES
        resteasy-atom-provider.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(HTTPCLIENT_JAR
    NAMES
        httpclient.jar
    PATHS
        /usr/share/java/httpcomponents
)

find_file(HTTPCORE_JAR
    NAMES
        httpcore.jar
    PATHS
        /usr/share/java/httpcomponents
)

# build pki-tomcat
javac(pki-tomcat8-classes
    SOURCES
        com/netscape/cms/tomcat/*.java
    CLASSPATH
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_SCAN_JAR} ${TOMCAT_API_JAR}
            ${CMAKE_BINARY_DIR}/../../tomcat
    OUTPUT_DIR
        ${CMAKE_BINARY_DIR}/../../tomcat
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/pki-tomcat.mf
    ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
)

jar(pki-tomcat-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
    INPUT_DIR
        ${CMAKE_BINARY_DIR}/../../tomcat
    FILES
        com/netscape/cms/tomcat/*.class
    DEPENDS
        pki-tomcat-classes
        pki-tomcat8-classes
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

set(PKI_TOMCAT_JAR ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar CACHE INTERNAL "pki-tomcat jar file")

=== debian/changelog ===
dogtag-pki (10.2.6+git20160317-1) unstable; urgency=medium

  * update to current 10_2_6_BRANCH.
    - refresh patches
    - add pki-user-membership.1 to pki-tools
    - tomcat7-build-fix.diff: Dropped, upstream.
  * rules: Mark systemd units disabled by default.
  * use-usr-bin.diff: Updated.
  * use-root-homedir.diff: Force home_dir to be /root, so that ipa works
    right.
  * control: Add conflicts on strongswan-pki.
  * pki-server: Remove default.cfg, logs on purge. (Closes: #814636)
  * pki-base: Remove pki.conf on purge. (Closes: #804312)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 05 Apr 2016 19:37:03 +0300

dogtag-pki (10.2.6-3) unstable; urgency=medium

  * pki-base.postrm: Remove upgrade logs on purge. (Closes: #801139)
  * use-usr-bin.diff: Fix paths to binaries to use /usr/bin instead of
    /bin.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 08 Jan 2016 02:18:17 +0200

dogtag-pki (10.2.6-2) unstable; urgency=medium

  * pki-server.dirs: Add pki-tomcatd-nuxwdog.target.wants.
  * base.postrm: No need to remove /etc/pki here.
  * debian-support.diff: Drop /etc/default/tomcat8, was a leftover from
    t8 testing. (Closes: #800558)
  * debian-support.diff: Import /lib/lsb/init-functions in
    scripts/operations. (Closes: #800559)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Oct 2015 08:14:52 +0300

=== debian/control ===
Source: dogtag-pki
Section: java
Priority: optional
Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends:
 apache2-dev,
 cmake,
 debhelper (>= 9),
 default-jdk,
 dh-systemd,
 javahelper,
 junit4,
 libcommons-cli-java,
 libcommons-codec-java,
 libcommons-io-java,
 libcommons-lang-java,
 libidm-console-framework-java,
 libjackson2-annotations-java,
 libjss-java,
 libldap-java,
 libldap2-dev,
 libnspr4-dev,
 libnss3-dev,
 libnuxwdog-java,
 libresteasy-java,
 libservlet3.0-java,
 libsvrcore-dev,
 libtomcat7-java,
 libtomcatjss-java (>= 7.1.0),
 libxalan2-java,
 libxerces2-java,
 pkg-config,
 policycoreutils,
 python-dev,
 python-sphinx,
 selinux-policy-dev,
 velocity,
 zlib1g-dev,
Standards-Version: 3.9.5
Homepage: http://pki.fedoraproject.org
Vcs-Git: git://anonscm.debian.org/pkg-freeipa/dogtag-pki.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-freeipa/dogtag-pki.git

Package: dogtag-pki
Architecture: all
Depends:
 dogtag-pki-console-theme,
 dogtag-pki-server-theme,
 pki-base,
 pki-ca,
 pki-console,
 pki-javadoc,
 pki-kra,
 pki-ocsp,
 pki-server,
 pki-tks,
 pki-tools,
 pki-tps,
 ${misc:Depends},
Description: Dogtag Public Key Infrastructure (PKI) Suite
 The Dogtag Public Key Infrastructure (PKI) Suite is comprised of the following
 five subsystems and a client (for use by a Token Management System):
 .
   * Certificate Authority (CA)
   * Data Recovery Manager (DRM)
   * Online Certificate Status Protocol (OCSP) Manager
   * Token Key Service (TKS)
   * Token Processing System (TPS)
   * Enterprise Security Client (ESC)
 .
 Additionally, it provides a console GUI application used for server and
 user/group administration of CA, DRM, OCSP, and TKS, javadocs on portions
 of the Dogtag API, as well as various command-line tools used to assist with
 a PKI deployment.

Package: pki-base
Architecture: any
Depends:
 libcommons-cli-java,
 libcommons-codec-java,
 libcommons-io-java,
 libcommons-lang-java,
 libcommons-logging-java,
 libjavassist-java,
 libjettison-java,
 libjss-java,
 libldap-java,
 libresteasy-java,
 libservlet3.0-java,
 libxalan2-java,
 libxerces2-java,
 libxml-commons-external-java,
 libxml-commons-resolver1.1-java,
 python-ldap,
 python-lxml,
 python-requests,
 ${java:Depends},
 ${misc:Depends},
 ${python:Depends},
Description: Certificate System - PKI Framework
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-tools
Architecture: any
Depends:
 ldap-utils,
 libjackson2-annotations-java,
 libnss3-tools,
 pki-base (= ${binary:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Conflicts: strongswan-starter, strongswan-pki
Description: Certificate System - PKI Tools
 This package contains PKI executables that can be used to help make
 Certificate System into a more complete and robust PKI solution.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-server
Architecture: any
Depends:
 adduser,
 dogtag-pki-server-theme (>= ${source:Version}),
 ldap-utils,
 libatk-wrapper-java,
 libjackson-json-java,
 libjackson2-annotations-java,
 libjackson2-jaxrs-providers-java,
 libjs-jquery,
 libjs-underscore,
 libtomcatjss-java (>= 7.1.0),
 libnuxwdog-java,
 libxml-commons-external-java,
 libxml-commons-resolver1.1-java,
 pki-base (= ${binary:Version}),
 pki-tools (= ${binary:Version}),
 python-selinux,
 tomcat7-user,
 velocity,
 ${java:Depends},
 ${misc:Depends},
 ${python:Depends},
Description: Certificate System - PKI Server Framework
 The PKI Server Framework is required by the following four PKI subsystems:
 .
     the Certificate Authority (CA),
     the Data Recovery Manager (DRM),
     the Online Certificate Status Protocol (OCSP) Manager, and
     the Token Key Service (TKS).
 .
 This package is a part of the PKI Core used by the Certificate System.
 The package contains scripts to create and remove PKI subsystems.

Package: pki-ca
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: 389-ds-base
Description: Certificate System - Certificate Authority
 The Certificate Authority (CA) is a required PKI subsystem which issues,
 renews, revokes, and publishes certificates as well as compiling and
 publishing Certificate Revocation Lists (CRLs).
 .
 The Certificate Authority can be configured as a self-signing Certificate
 Authority, where it is the root CA, or it can act as a subordinate CA,
 where it obtains its own signing certificate from a public CA.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: dogtag-pki-console-theme
Architecture: all
Section: web
Depends: ${java:Depends}, ${misc:Depends}
Description: Certificate System - PKI Console User Interface
 This PKI Console User Interface contains the Dogtag textual
 and graphical user interface for the PKI Console.
 .
 This package is used by the Dogtag Certificate System.

Package: dogtag-pki-server-theme
Architecture: all
Section: web
Depends: ${java:Depends}, ${misc:Depends}
Description: Certificate System - PKI Server User Interface
 This PKI Common Framework User Interface contains the Dogtag
 textual and graphical user interface for the PKI Common Framework.
 .
 This package is used by the Dogtag Certificate System.

Package: pki-console
Architecture: all
Depends:
 dogtag-pki-console-theme,
 libidm-console-framework-java,
 libjss-java,
 libldap-java,
 pki-base (>= 10.0),
 ${java:Depends},
 ${misc:Depends},
Description: Certificate System - PKI Console
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The PKI Console is a java application used to administer CS.

Package: pki-kra
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: pki-ca
Description: Certificate System - Data Recovery Manager
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Data Recovery Manager (DRM) is an optional PKI subsystem that can act
 as a Key Recovery Authority (KRA).  When configured in conjunction with the
 Certificate Authority (CA), the DRM stores private encryption keys as part of
 the certificate enrollment process.  The key archival mechanism is triggered
 when a user enrolls in the PKI and creates the certificate request.  Using the
 Certificate Request Message Format (CRMF) request format, a request is
 generated for the user's private encryption key.  This key is then stored in
 the DRM which is configured to store keys in an encrypted format that can only
 be decrypted by several agents requesting the key at one time, providing for
 protection of the public encryption keys for the users in the PKI deployment.
 .
 Note that the DRM archives encryption keys; it does NOT archive signing keys,
 since such archival would undermine non-repudiation properties of signing keys.

Package: pki-ocsp
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: pki-ca
Description: Certificate System - Online Certificate Status Protocol Manager
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Online Certificate Status Protocol (OCSP) Manager is an optional PKI
 subsystem that can act as a stand-alone OCSP service.  The OCSP Manager
 performs the task of an online certificate validation authority by enabling
 OCSP-compliant clients to do real-time verification of certificates.  Note
 that an online certificate-validation authority is often referred to as an
 OCSP Responder.
 .
 Although the Certificate Authority (CA) is already configured with an
 internal OCSP service.  An external OCSP Responder is offered as a separate
 subsystem in case the user wants the OCSP service provided outside of a
 firewall while the CA resides inside of a firewall, or to take the load of
 requests off of the CA.
 .
 The OCSP Manager can receive Certificate Revocation Lists (CRLs) from
 multiple CA servers, and clients can query the OCSP Manager for the
 revocation status of certificates issued by all of these CA servers.
 .
 When an instance of OCSP Manager is set up with an instance of CA, and
 publishing is set up to this OCSP Manager, CRLs are published to it
 whenever they are issued or updated.

Package: pki-tks
Architecture: all
Depends:
 libsymkey-java (>= ${source:Version}),
 pki-server (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
Suggests: pki-ca
Description: Certificate System - Token Key Service
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Token Key Service (TKS) is an optional PKI subsystem that manages the
 master key(s) and the transport key(s) required to generate and distribute
 keys for hardware tokens.  TKS provides the security between tokens and an
 instance of Token Processing System (TPS), where the security relies upon the
 relationship between the master key and the token keys.  A TPS communicates
 with a TKS over SSL using client authentication.
 .
 TKS helps establish a secure channel (signed and encrypted) between the token
 and the TPS, provides proof of presence of the security token during
 enrollment, and supports key changeover when the master key changes on the
 TKS.  Tokens with older keys will get new token keys.
 .
 Because of the sensitivity of the data that TKS manages, TKS should be set up
 behind the firewall with restricted access.

Package: pki-tps
Architecture: all
Depends:
 pki-server (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: pki-ca, pki-kra, pki-tks
Description: Certificate System - Token Processing System
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Token Processing System (TPS) is an optional PKI subsystem that acts
 as a Registration Authority (RA) for authenticating and processing
 enrollment requests, PIN reset requests, and formatting requests from
 the Enterprise Security Client (ESC).
 .
 TPS is designed to communicate with tokens that conform to
 Global Platform's Open Platform Specification.
 .
 TPS communicates over SSL with various PKI backend subsystems (including
 the Certificate Authority (CA), the Data Recovery Manager (DRM), and the
 Token Key Service (TKS)) to fulfill the user's requests.
 .
 TPS also interacts with the token database, an LDAP server that stores
 information about individual tokens.

Package: pki-tps-client
Architecture: any
Depends:
 libsymkey-java (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Certificate System - Token Processing System client
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Token Processing System (TPS) is an optional PKI subsystem that acts
 as a Registration Authority (RA) for authenticating and processing
 enrollment requests, PIN reset requests, and formatting requests from
 the Enterprise Security Client (ESC).
 .
 TPS is designed to communicate with tokens that conform to
 Global Platform's Open Platform Specification.
 .
 TPS communicates over SSL with various PKI backend subsystems (including
 the Certificate Authority (CA), the Data Recovery Manager (DRM), and the
 Token Key Service (TKS)) to fulfill the user's requests.
 .
 TPS also interacts with the token database, an LDAP server that stores
 information about individual tokens.
 .
 This client is a test tool that interacts with TPS. It is useful to test

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

VER :=  $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)-.*$$/\1/ p' | sed -e 's/~.*//')

JAVA_HOME=/usr/lib/jvm/default-java
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS += -I/usr/include/nss $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS += -I/usr/include/nss -I/usr/include/apr-1.0 $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS += $(shell dpkg-buildflags --get LDFLAGS)
DEB_BUILD_DIR ?= $(CURDIR)/build

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE_FLAGS += -j$(NUMJOBS)
endif

CONFIGS = core \
	  console \
	  dogtag-pki-theme

STAMP_DIR = debian/stamp
STAMP = $(STAMP_DIR)/$(DEB_BUILD_GNU_TYPE)
BUILD_STAMPS = $(addprefix $(STAMP)-build-, $(CONFIGS))

confflags = 

confflags-common = $(confflags) \
	-DVERSION=$(VER) \
	-DSYSTEMD_LIB_INSTALL_DIR=/lib/systemd/system \
	-DVAR_INSTALL_DIR:PATH=/var \
	-DRESTEASY_LIB=/usr/share/java/ \
	-DPKI_CERTSRV_JAR=$(DEB_BUILD_DIR)/core/dist/pki-certsrv.jar \
	-DPKI_CMS_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cms.jar \
	-DPKI_CMSBUNDLE_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmsbundle.jar \
	-DPKI_CMSCORE_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmscore.jar \
	-DPKI_CMSUTIL_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmsutil.jar \
	-DPKI_NSUTIL_JAR=$(DEB_BUILD_DIR)/core/dist/pki-nsutil.jar \
	-DHTTPCLIENT_JAR=/usr/share/java/httpclient.jar \
	-DHTTPCORE_JAR=/usr/share/java/httpcore.jar \
	-DTOMCAT_CATALINA_JAR=/usr/share/java/tomcat-catalina.jar \
	-DTOMCAT_UTIL_JAR=/usr/share/java/tomcat-util.jar \

confflags-core = \
	-DBUILD_PKI_CORE:BOOL=ON \
	-DAPACHE_COMMONS_CLI_JAR=/usr/share/java/commons-cli.jar \
	-DAPACHE_COMMONS_LANG_JAR=/usr/share/java/commons-lang.jar \
	-DSERVLET_JAR=/usr/share/java/servlet-api-3.0.jar \
	-DXERCES_JAR=/usr/share/java/xercesImpl.jar \
	-DXALAN_JAR=/usr/share/java/xalan2.jar \
	-DWITH_TOMCAT8:BOOL=OFF \
	$(confflags-common)

confflags-console = \
	-DBUILD_PKI_CONSOLE:BOOL=ON \
	$(confflags-common)

confflags-dogtag-pki-theme = \
	-DBUILD_DOGTAG_PKI_THEME:BOOL=ON \
	$(confflags-common)

%:
	dh $@ --parallel --with javahelper,python2,systemd,apache2 --builddirectory=build/

override_dh_auto_clean:
	rm -rf $(CURDIR)/build

override_dh_auto_configure:

build-stamp: $(BUILD_STAMPS)
	>$@

$(STAMP)-build-%:
	mkdir -p $(DEB_BUILD_DIR)/$*
	cd $(DEB_BUILD_DIR)/$* && \
	cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DSYSCONF_INSTALL_DIR:PATH=/etc \
		-DVAR_INSTALL_DIR:PATH=/var \
		-DJAVA_LIB_INSTALL_DIR=/usr/share/java \
		$(confflags-$*) \
		../../
	cd $(DEB_BUILD_DIR)/$* && make VERBOSE=1 $(MAKE_FLAGS)

override_dh_auto_build: build-stamp

override_dh_auto_install:
	set -e; for config in $(CONFIGS); do \
		make -C $(DEB_BUILD_DIR)/$$config DESTDIR=$(CURDIR)/debian/tmp install; \
	done

	find $(CURDIR)/debian/tmp/usr/share/pki -name '*.cgi' -exec chmod 755 '{}' ';'
	find $(CURDIR)/debian/tmp/usr/share/pki -name '*.pl' -exec chmod 755 '{}' ';'
	find $(CURDIR)/debian/tmp/lib/systemd -exec chmod 644 '{}' ';'

	# Create symlinks for subsystem libraries
	for subsys in ca kra ocsp tks tps; do \
		mkdir -p $(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-nsutil.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-cmsutil.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-certsrv.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-cms.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-cmscore.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-cmsbundle.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
		ln -s /usr/share/java/pki/pki-$$subsys.jar \
			$(CURDIR)/debian/tmp/usr/share/pki/$$subsys/webapps/$$subsys/WEB-INF/lib ;\
	done

override_dh_installinit:
	dh_installinit -ppki-server --name=pki-tomcatd --error-handler=invoke_failure

override_dh_systemd_enable:
	dh_systemd_enable -ppki-server --no-enable pki-tomcatd@.service
	dh_systemd_enable -ppki-server --no-enable pki-tomcatd-nuxwdog@.service

override_dh_install:
	# we don't use these
	rm -rf $(CURDIR)/debian/tmp/etc/rc.d

	# tpsclient hasn't been ported to java yet
	rm -rf $(CURDIR)/debian/tmp/lib/systemd/system/pki-tpsd* \
		$(CURDIR)/debian/tmp/usr/lib/httpd/modules/mod_tps.so \
		$(CURDIR)/debian/tmp/usr/lib/httpd/modules/mod_tokendb.so \
		$(CURDIR)/debian/tmp/usr/lib/tps/libldapauth.so \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/cgi-bin \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/docroot \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/lib \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/scripts \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/samples

	# empty dir
	rm -rf $(CURDIR)/debian/tmp/usr/share/pki/server/lib
	# not needed since we don't ship any binary applets
	rm -rf $(CURDIR)/debian/tmp/usr/share/pki/tps/applets

	dh_install --fail-missing

get-orig-source: SOURCE=dogtag-pki
get-orig-source: UV=$(shell dpkg-parsechangelog|awk '/^Version:/ {print $$2}'|sed 's/-.*$$//')
get-orig-source:
	tar --transform 's,^,$(SOURCE)-$(UV)/,' \
		--exclude 'debian' --exclude-vcs \
		-cJf ../$(SOURCE)_$(UV).orig.tar.xz .

=== debian/watch ===
# 'debian/rules gentarball' used instead, since the tarball needs to be generated
